/* Header for VGA to NTSC converting software */
/* 

   Copyright 1994, 1995, 1996, 1997, 1998, 1999  by Bernie Roehl 

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA,
   02111-1307, USA.

   For more information, contact Bernie Roehl <broehl@uwaterloo.ca> 
   or at Bernie Roehl, 68 Margaret Avenue North, Waterloo, Ontario, 
   N2J 3P7, Canada

*/

typedef struct {              // VGA atributes
  unsigned char MOR,      // Misccellaneous Output register
		FCR,      // Feature Control Register
		ISR0,     // Input Status Register 0
		ISR1,     // Input Status Register 1
		SR[5],
		CRCT[25]; // Catode Ray Tybe Controller registers
} VGAatr;

/**************************** NTSC frequencies **************************/
VGAatr VGA3 = { 0x27, 1, 0x10, 0x31,             // text mode 80x24 char
		3, 9, 3, 0, 2,
		0x6b, 0x4f, 0x50, 0x8e,
		0x5d, 0x85, 0x4, 0x11,
		0, 0x47, 0xd, 0xe, 0, 0, 0,
		0xf0, 0xdf, 0xa2, 0xc7, 0x28,
		0x1f, 0xdc, 0xf0, 0xa3, 0xff};

VGAatr VGAe = { 0x27, 1, 0x10, 0x30,         // 640x200x16
		3, 9, 0xf, 0, 6,
		0x6b, 0x4f, 0x50, 0x8e,
		0x5d, 0x85, 0x4, 0x11,
		0, 0x40, 0, 0, 0, 0, 0,
		0, 0xdf, 0xa2, 0xc7, 0x28,
		0, 0xdc, 0xf0, 0xe3, 0xff};

VGAatr VGA10 = { 0x27, 1, 0x10, 0x31,     // 640x350x16
		 3, 9, 0xf, 0, 6,
		 0x6b, 0x4f, 0x50, 0x8e,
		 0x5d, 0x85, 0x4, 0x11,
		 0, 0x40, 0, 0, 0, 0, 0,
		 0, 0xd4, 0xa7, 0xae, 0x50,
		 0xf, 0xd3, 0xdf, 0xe3, 0xff};

VGAatr VGA12 = { 0x27, 1, 0x10, 0x30,     // 640x480x16
		 3, 9, 0xf, 0, 6,
		 0x6b, 0x4f, 0x50, 0x8e,
		 0x5d, 0x85, 0x8, 0x11,
		 0, 0x40, 0, 0, 0, 0, 0,
		 0, 0xf3, 0xa6, 0xef, 0x50,
		 0, 0xf3, 0xff, 0xc3, 0xff};

VGAatr VGA13 = { 0x27, 0x0, 0x10, 0x4,
		 0x3, 0x9, 0xf, 0x0, 0xe,
		 0x16b, 0x14f, 0x150, 0x18e, 0x15c,
		 0x184, 0x104, 0x111, 0x100, 0x140,
		 0x100, 0x100, 0x100, 0x100, 0x100,
		 0x100, 0x1df, 0x1a2, 0x1c7, 0x128,
		 0x140, 0x1dc, 0x1f0, 0x1a3, 0x1ff };

/************************************************************************/

/****************************** VGA frequencies *************************/
VGAatr VGAi3 = { 0x67, 0x0, 0x10, 0x4,
		 0x3, 0x0, 0x3, 0x0, 0x2,
		 0x5f, 0x4f, 0x50, 0x82, 0x55,
		 0x81, 0xbf, 0x1f, 0x0, 0x4f, 0xd,
		 0xe, 0x0, 0x0, 0x0, 0x0, 0x9c,
		 0x8e, 0x8f, 0x28, 0x1f, 0x96,
		 0xb9, 0xa3, 0xff};

VGAatr VGAie = { 0x63, 0x0, 0x10, 0x5,
		 0x3, 0x1, 0xf, 0x0, 0x6,
		 0x5f, 0x4f, 0x50, 0x82, 0x54,
		 0x80, 0xbf, 0x1f, 0x0, 0xc0,
		 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
		 0x9c, 0x8e, 0x8f, 0x28, 0x0,
		 0x96, 0xb9, 0xe3, 0xff};

VGAatr VGAi10 = { 0xa3, 0x0, 0x10, 0x5,
		  0x3, 0x1, 0xf, 0x0, 0x6,
		  0x5f, 0x4f, 0x50, 0x82, 0x54,
		  0x80, 0xbf, 0x1f, 0x0, 0x40,
		  0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
		  0x83, 0x85, 0x5d, 0x28, 0xf,
		  0x63, 0xba, 0xe3, 0xff};

VGAatr VGAi11 = { 0xe3, 0x0, 0x10, 0x4,
		  0x3, 0x1, 0xf, 0x0, 0x6,
		  0x5f, 0x4f, 0x50, 0x82, 0x54,
		  0x80, 0xb, 0x3e, 0x0, 0x40, 0x0,
		  0x0, 0x0, 0x0, 0x0, 0x0, 0xea,
		  0x8c, 0xdf, 0x28, 0x0, 0xe7,
		  0x4, 0xc3, 0xff};

VGAatr VGAi12 = { 0xe3, 0x0, 0x10, 0x4,
		  0x3, 0x1, 0xf, 0x0, 0x6,
		  0x5f, 0x4f, 0x50, 0x82, 0x54,
		  0x80, 0xb, 0x3e, 0x0, 0x40, 0x0,
		  0x0, 0x0, 0x0, 0x0, 0x0, 0xea,
		  0x8c, 0xdf, 0x28, 0x0, 0xe7,
		  0x4, 0xe3, 0xff};

VGAatr VGAi13 = { 0x63, 0x0, 0x10, 0x5,
		  0x3, 0x1, 0xf, 0x0, 0xe,
		  0x15f, 0x14f, 0x150, 0x182, 0x154,
		  0x180, 0x1bf, 0x11f, 0x100, 0x141,
		  0x100, 0x100, 0x100, 0x100, 0x100,
		  0x100, 0x19c, 0x18e, 0x18f, 0x128,
		  0x140, 0x196, 0x1b9, 0x1a3, 0x1ff };
/************************************************************************/
