/* Palette handling routines; part of AVRIL */
/* 

   Copyright 1994, 1995, 1996, 1997, 1998, 1999  by Bernie Roehl 

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA,
   02111-1307, USA.

   For more information, contact Bernie Roehl <broehl@uwaterloo.ca> 
   or at Bernie Roehl, 68 Margaret Avenue North, Waterloo, Ontario, 
   N2J 3P7, Canada

*/

#include "avril.h"
#include "palettes.h"

void vrl_PaletteInit(vrl_Palette *pal)
	{
	if (pal)
		memcpy(pal, &default_palette_256, sizeof(default_palette_256));
	}

int vrl_PaletteRead(FILE *in, vrl_Palette *pal)
	{
	if (pal == NULL || in == NULL) return -1;
	vrl_PaletteInit(pal);
	if (fread(pal->data, 3, 256, in) != 256) return -2;
	fread(pal->huemap, 2, 256, in);
	pal->changed = 1;
	return 0;
	}

vrl_Color vrl_PaletteGetEntry(vrl_Palette *pal, int n)
	{
	return (((vrl_Color) pal->data[n][0]) << 16)
		+ (((vrl_Color) pal->data[n][1]) << 8)
		+ ((vrl_Color) pal->data[n][2]);
	}

void vrl_PaletteSetEntry(vrl_Palette *pal, int n, vrl_Color color)
	{
	pal->data[n][0] = color >> 16;
	pal->data[n][1] = color >> 8;
	pal->data[n][2] = color;
	}
